# Server plugin: UpstreamCA "awssecret"

The `awssecret` plugin loads root CA credentials from AWS SecretsManager, using
them to generate intermediate signing certificates for the server's signing
authority. The intermediate certificates are minted against CSRs generated by
the ServerCA plugin.

The plugin accepts the following configuration options:

| Configuration           | Description                           |
| ----------------------- | ------------------------------------- |
| ttl                     | The TTL for issued certificates       |
| region                  | AWS Region to use                     |
| cert_file_arn           | ARN of the "upstream" CA certificate  |
| key_file_arn            | ARN of the "upstream" CA key file     |
| access_key_id           | AWS access key ID                     |
| secret_access_key       | AWS secret access key                 |
| secret_token            | AWS secret token                      |
| assume_role_arn         | ARN of role to assume                 |

A sample configuration:

```
    UpstreamCA "awssecret" {
        plugin_data {
            ttl = "1h",
            region = "us-west-2",
            cert_file_arn = "cert",
            key_file_arn = "key",
            access_key_id = "ACCESS_KEY_ID",
            secret_access_key = "SECRET_ACCESS_KEY",
            secret_token = "SECRET_TOKEN"
            assume_role_arn = "role"
        }
    }
```
