// Code generated by protoc-gen-go. DO NOT EDIT.
// source: journal.proto

package ca

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

type X509CAEntry struct {
	// Which X509 CA slot this entry occupied.
	SlotId string `protobuf:"bytes,1,opt,name=slot_id,json=slotId,proto3" json:"slot_id,omitempty"`
	// When the CA was issued (unix epoch in seconds)
	IssuedAt int64 `protobuf:"varint,2,opt,name=issued_at,json=issuedAt,proto3" json:"issued_at,omitempty"`
	// DER encoded CA certificate
	Certificate []byte `protobuf:"bytes,3,opt,name=certificate,proto3" json:"certificate,omitempty"`
	// DER encoded upstream CA chain. See the X509CA struct for details.
	UpstreamChain        [][]byte `protobuf:"bytes,4,rep,name=upstream_chain,json=upstreamChain,proto3" json:"upstream_chain,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *X509CAEntry) Reset()         { *m = X509CAEntry{} }
func (m *X509CAEntry) String() string { return proto.CompactTextString(m) }
func (*X509CAEntry) ProtoMessage()    {}
func (*X509CAEntry) Descriptor() ([]byte, []int) {
	return fileDescriptor_04fd98cceb1b9191, []int{0}
}

func (m *X509CAEntry) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_X509CAEntry.Unmarshal(m, b)
}
func (m *X509CAEntry) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_X509CAEntry.Marshal(b, m, deterministic)
}
func (m *X509CAEntry) XXX_Merge(src proto.Message) {
	xxx_messageInfo_X509CAEntry.Merge(m, src)
}
func (m *X509CAEntry) XXX_Size() int {
	return xxx_messageInfo_X509CAEntry.Size(m)
}
func (m *X509CAEntry) XXX_DiscardUnknown() {
	xxx_messageInfo_X509CAEntry.DiscardUnknown(m)
}

var xxx_messageInfo_X509CAEntry proto.InternalMessageInfo

func (m *X509CAEntry) GetSlotId() string {
	if m != nil {
		return m.SlotId
	}
	return ""
}

func (m *X509CAEntry) GetIssuedAt() int64 {
	if m != nil {
		return m.IssuedAt
	}
	return 0
}

func (m *X509CAEntry) GetCertificate() []byte {
	if m != nil {
		return m.Certificate
	}
	return nil
}

func (m *X509CAEntry) GetUpstreamChain() [][]byte {
	if m != nil {
		return m.UpstreamChain
	}
	return nil
}

type JWTKeyEntry struct {
	// Which JWT Key slot this entry occupied.
	SlotId string `protobuf:"bytes,1,opt,name=slot_id,json=slotId,proto3" json:"slot_id,omitempty"`
	// When the key was issued (unix epoch in seconds)
	IssuedAt int64 `protobuf:"varint,2,opt,name=issued_at,json=issuedAt,proto3" json:"issued_at,omitempty"`
	// When the key expires unix epoch in seconds)
	NotAfter int64 `protobuf:"varint,3,opt,name=not_after,json=notAfter,proto3" json:"not_after,omitempty"`
	// JWT key id (i.e. "kid" claim)
	Kid string `protobuf:"bytes,4,opt,name=kid,proto3" json:"kid,omitempty"`
	// PKIX encoded public key
	PublicKey            []byte   `protobuf:"bytes,5,opt,name=public_key,json=publicKey,proto3" json:"public_key,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *JWTKeyEntry) Reset()         { *m = JWTKeyEntry{} }
func (m *JWTKeyEntry) String() string { return proto.CompactTextString(m) }
func (*JWTKeyEntry) ProtoMessage()    {}
func (*JWTKeyEntry) Descriptor() ([]byte, []int) {
	return fileDescriptor_04fd98cceb1b9191, []int{1}
}

func (m *JWTKeyEntry) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_JWTKeyEntry.Unmarshal(m, b)
}
func (m *JWTKeyEntry) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_JWTKeyEntry.Marshal(b, m, deterministic)
}
func (m *JWTKeyEntry) XXX_Merge(src proto.Message) {
	xxx_messageInfo_JWTKeyEntry.Merge(m, src)
}
func (m *JWTKeyEntry) XXX_Size() int {
	return xxx_messageInfo_JWTKeyEntry.Size(m)
}
func (m *JWTKeyEntry) XXX_DiscardUnknown() {
	xxx_messageInfo_JWTKeyEntry.DiscardUnknown(m)
}

var xxx_messageInfo_JWTKeyEntry proto.InternalMessageInfo

func (m *JWTKeyEntry) GetSlotId() string {
	if m != nil {
		return m.SlotId
	}
	return ""
}

func (m *JWTKeyEntry) GetIssuedAt() int64 {
	if m != nil {
		return m.IssuedAt
	}
	return 0
}

func (m *JWTKeyEntry) GetNotAfter() int64 {
	if m != nil {
		return m.NotAfter
	}
	return 0
}

func (m *JWTKeyEntry) GetKid() string {
	if m != nil {
		return m.Kid
	}
	return ""
}

func (m *JWTKeyEntry) GetPublicKey() []byte {
	if m != nil {
		return m.PublicKey
	}
	return nil
}

type JournalEntries struct {
	X509CAs              []*X509CAEntry `protobuf:"bytes,1,rep,name=x509CAs,proto3" json:"x509CAs,omitempty"`
	JwtKeys              []*JWTKeyEntry `protobuf:"bytes,2,rep,name=jwtKeys,proto3" json:"jwtKeys,omitempty"`
	XXX_NoUnkeyedLiteral struct{}       `json:"-"`
	XXX_unrecognized     []byte         `json:"-"`
	XXX_sizecache        int32          `json:"-"`
}

func (m *JournalEntries) Reset()         { *m = JournalEntries{} }
func (m *JournalEntries) String() string { return proto.CompactTextString(m) }
func (*JournalEntries) ProtoMessage()    {}
func (*JournalEntries) Descriptor() ([]byte, []int) {
	return fileDescriptor_04fd98cceb1b9191, []int{2}
}

func (m *JournalEntries) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_JournalEntries.Unmarshal(m, b)
}
func (m *JournalEntries) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_JournalEntries.Marshal(b, m, deterministic)
}
func (m *JournalEntries) XXX_Merge(src proto.Message) {
	xxx_messageInfo_JournalEntries.Merge(m, src)
}
func (m *JournalEntries) XXX_Size() int {
	return xxx_messageInfo_JournalEntries.Size(m)
}
func (m *JournalEntries) XXX_DiscardUnknown() {
	xxx_messageInfo_JournalEntries.DiscardUnknown(m)
}

var xxx_messageInfo_JournalEntries proto.InternalMessageInfo

func (m *JournalEntries) GetX509CAs() []*X509CAEntry {
	if m != nil {
		return m.X509CAs
	}
	return nil
}

func (m *JournalEntries) GetJwtKeys() []*JWTKeyEntry {
	if m != nil {
		return m.JwtKeys
	}
	return nil
}

func init() {
	proto.RegisterType((*X509CAEntry)(nil), "X509CAEntry")
	proto.RegisterType((*JWTKeyEntry)(nil), "JWTKeyEntry")
	proto.RegisterType((*JournalEntries)(nil), "JournalEntries")
}

func init() { proto.RegisterFile("journal.proto", fileDescriptor_04fd98cceb1b9191) }

var fileDescriptor_04fd98cceb1b9191 = []byte{
	// 286 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x91, 0x41, 0x4b, 0xc3, 0x30,
	0x14, 0xc7, 0xc9, 0x32, 0xb7, 0xf5, 0x75, 0x1b, 0x92, 0x8b, 0x81, 0x21, 0x84, 0x81, 0xd2, 0xd3,
	0x10, 0xc5, 0x83, 0xc7, 0x39, 0x3c, 0xb8, 0xdd, 0x82, 0xa0, 0x78, 0xa9, 0x59, 0x9b, 0x61, 0xb6,
	0xd9, 0x8c, 0xe4, 0x15, 0xed, 0x77, 0xf0, 0xe2, 0x37, 0x96, 0x74, 0x16, 0x7a, 0xf7, 0x96, 0xf7,
	0x7b, 0x7f, 0xc2, 0x2f, 0xff, 0xc0, 0x68, 0x6b, 0x4b, 0x57, 0xa8, 0xfd, 0xec, 0xe0, 0x2c, 0xda,
	0xe9, 0x37, 0x81, 0xf8, 0xe5, 0xf6, 0xea, 0x6e, 0x31, 0x7f, 0x28, 0xd0, 0x55, 0xec, 0x0c, 0xfa,
	0x7e, 0x6f, 0x31, 0x35, 0x39, 0x27, 0x82, 0x24, 0x91, 0xec, 0x85, 0xf1, 0x31, 0x67, 0x13, 0x88,
	0x8c, 0xf7, 0xa5, 0xce, 0x53, 0x85, 0xbc, 0x23, 0x48, 0x42, 0xe5, 0xe0, 0x08, 0xe6, 0xc8, 0x04,
	0xc4, 0x99, 0x76, 0x68, 0x36, 0x26, 0x53, 0xa8, 0x39, 0x15, 0x24, 0x19, 0xca, 0x36, 0x62, 0x17,
	0x30, 0x2e, 0x0f, 0x1e, 0x9d, 0x56, 0x1f, 0x69, 0xf6, 0xae, 0x4c, 0xc1, 0xbb, 0x82, 0x26, 0x43,
	0x39, 0x6a, 0xe8, 0x22, 0xc0, 0xe9, 0x0f, 0x81, 0x78, 0xf9, 0xfc, 0xb4, 0xd2, 0xd5, 0x7f, 0x74,
	0x26, 0x10, 0x15, 0x16, 0x53, 0xb5, 0x41, 0xed, 0x6a, 0x19, 0x2a, 0x07, 0x85, 0xc5, 0x79, 0x98,
	0xd9, 0x29, 0xd0, 0x9d, 0xc9, 0x79, 0xb7, 0xbe, 0x2e, 0x1c, 0xd9, 0x39, 0xc0, 0xa1, 0x5c, 0xef,
	0x4d, 0x96, 0xee, 0x74, 0xc5, 0x4f, 0x6a, 0xf9, 0xe8, 0x48, 0x56, 0xba, 0x9a, 0xbe, 0xc1, 0x78,
	0x79, 0xec, 0x2c, 0x38, 0x19, 0xed, 0xd9, 0x25, 0xf4, 0xbf, 0xea, 0xce, 0x3c, 0x27, 0x82, 0x26,
	0xf1, 0xf5, 0x70, 0xd6, 0xea, 0x50, 0x36, 0xcb, 0x90, 0xdb, 0x7e, 0xe2, 0x4a, 0x57, 0x9e, 0x77,
	0xfe, 0x72, 0xad, 0xc7, 0xc9, 0x66, 0x79, 0xdf, 0x7d, 0xed, 0x64, 0x6a, 0xdd, 0xab, 0x7f, 0xe4,
	0xe6, 0x37, 0x00, 0x00, 0xff, 0xff, 0x58, 0x50, 0x0f, 0x00, 0xa2, 0x01, 0x00, 0x00,
}
